IdentifiantMot de passe
Loading...
Mot de passe oublié ?Je m'inscris ! (gratuit)
Navigation

Inscrivez-vous gratuitement
pour pouvoir participer, suivre les réponses en temps réel, voter pour les messages, poser vos propres questions et recevoir la newsletter

Réseau/Web Python Discussion :

Problème de boucle et API Discord [Python 3.X]


Sujet :

Réseau/Web Python

  1. #1
    Candidat au Club
    Homme Profil pro
    Étudiant
    Inscrit en
    octobre 2020
    Messages
    2
    Détails du profil
    Informations personnelles :
    Sexe : Homme
    Localisation : France, Paris (Île de France)

    Informations professionnelles :
    Activité : Étudiant

    Informations forums :
    Inscription : octobre 2020
    Messages : 2
    Points : 3
    Points
    3
    Par défaut Problème de boucle et API Discord
    Bonjour, et merci d'avance à quiconque me prêtera un peu de son temps.

    Je débute en programmation et me suis lancé comme objectif de créer un Bot Discord fonctionnel pour mon serveur. Je trouvais que c'était une façon simple de coder quelque chose de concret qui pourrait m'apprendre un peu comment fonctionne Python et la programmation en général.

    Cependant je me retrouve vite bloqué face à un problème que je ne comprends ni n'arrive à résoudre. Je suis sur python 3.8.3, W10 et utilise la console de SPYDER pour exécuter le programme qui suit :
    Code : Sélectionner tout - Visualiser dans une fenêtre à part
    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
     
    import discord
    from discord.ext import commands 
     
    bot = commands.Bot(command_prefix = "!", description = "Jiji")
     
    @bot.event
    async def on_ready():
        print("Ready !")
     
    bot.run("Token du bot")
    Et alors que je devrais recevoir un petit Ready ! dans la console et voir mon bot être en ligne sur mon serveur je reçois l'erreur :
    runfile('C:/Users/Bot jiji')
    Traceback (most recent call last):

    File "C:\ProgramData\Anaconda3\lib\site-packages\discord\client.py", line 698, in run
    loop.run_forever()

    File "C:\ProgramData\Anaconda3\lib\asyncio\base_events.py", line 560, in run_forever
    self._check_running()

    File "C:\ProgramData\Anaconda3\lib\asyncio\base_events.py", line 552, in _check_running
    raise RuntimeError('This event loop is already running')

    RuntimeError: This event loop is already running


    During handling of the above exception, another exception occurred:

    Traceback (most recent call last):

    File "C:\ProgramData\Anaconda3\lib\site-packages\discord\client.py", line 92, in _cleanup_loop
    _cancel_tasks(loop)

    File "C:\ProgramData\Anaconda3\lib\site-packages\discord\client.py", line 77, in _cancel_tasks
    loop.run_until_complete(asyncio.gather(*tasks, return_exceptions=True))

    File "C:\ProgramData\Anaconda3\lib\asyncio\base_events.py", line 592, in run_until_complete
    self._check_running()

    File "C:\ProgramData\Anaconda3\lib\asyncio\base_events.py", line 552, in _check_running
    raise RuntimeError('This event loop is already running')

    RuntimeError: This event loop is already running


    During handling of the above exception, another exception occurred:

    Traceback (most recent call last):

    File "C:\Users\Bot jiji\BOT.py", line 27, in <module>
    bot.run("NzYwNDUyMjE2Nzc1MjQ1ODI1.X3MQUA.3q3sckhjqz4ySPMwPIo1rlKTIyM")

    File "C:\ProgramData\Anaconda3\lib\site-packages\discord\client.py", line 704, in run
    _cleanup_loop(loop)

    File "C:\ProgramData\Anaconda3\lib\site-packages\discord\client.py", line 97, in _cleanup_loop
    loop.close()

    File "C:\ProgramData\Anaconda3\lib\asyncio\selector_events.py", line 89, in close
    raise RuntimeError("Cannot close a running event loop")

    RuntimeError: Cannot close a running event loop
    J'ai essayé de mettre des stop(), de comprendre la libraire discord.py pour voir ce qui n'allait pas, mais je ne suis pas encore assez compétent pour comprendre à quoi c'est du.

    Je suis preneur de toute aide. Merci d'avance !

  2. #2
    Expert confirmé
    Avatar de jurassic pork
    Homme Profil pro
    Bidouilleur
    Inscrit en
    décembre 2008
    Messages
    1 982
    Détails du profil
    Informations personnelles :
    Sexe : Homme
    Localisation : France

    Informations professionnelles :
    Activité : Bidouilleur
    Secteur : Industrie

    Informations forums :
    Inscription : décembre 2008
    Messages : 1 982
    Points : 5 015
    Points
    5 015
    Par défaut
    hello,
    as-tu essayé de lancer ton script dans une console (pas dans spyder) ?
    si cela fonctionne, il se pourrait bien que ce soit spyder qui te pose problème. Voir ici

    Ami calmant, J.P
    Jurassic computer : Sinclair ZX81 - Zilog Z80A à 3,25 MHz - RAM 1 Ko - ROM 8 Ko

  3. #3
    Candidat au Club
    Homme Profil pro
    Étudiant
    Inscrit en
    octobre 2020
    Messages
    2
    Détails du profil
    Informations personnelles :
    Sexe : Homme
    Localisation : France, Paris (Île de France)

    Informations professionnelles :
    Activité : Étudiant

    Informations forums :
    Inscription : octobre 2020
    Messages : 2
    Points : 3
    Points
    3
    Par défaut Enfin !
    C'était effectivement un problème avec spyder. Et plus particulièrement avec Jupyter. Au vu de leur billet de blog, ils ont mit en place une façon plus simple de faire des fonctions asynchrones... Mais j'y comprends pas grand chose et dans mon cas plus rien de marche alors que je n'avais pas d'erreur apparente. J'ai réglé le PATH sur python dans la console et est abandonné Spyder. Le même code fonctionne parfaitement maintenant !

    Merci beaucoup !

+ Répondre à la discussion
Cette discussion est résolue.

Discussions similaires

  1. Problème de boucle
    Par Louis-Guillaume Morand dans le forum Langage SQL
    Réponses: 3
    Dernier message: 25/09/2005, 09h10
  2. problème de liens avec API sous VC++
    Par xavynfive dans le forum MFC
    Réponses: 7
    Dernier message: 26/08/2005, 12h01
  3. (Problème) Utilisation de l'API mySQL [Delphi 2005 Perso]
    Par will-scs dans le forum Bases de données
    Réponses: 2
    Dernier message: 08/08/2005, 18h26
  4. Problème de boucle
    Par basclln dans le forum C++
    Réponses: 19
    Dernier message: 02/04/2005, 09h13
  5. [VB.NET] Problème pour Marshaliser une API
    Par lamalice dans le forum Windows Forms
    Réponses: 2
    Dernier message: 04/03/2005, 10h01

Partager

Partager
  • Envoyer la discussion sur Viadeo
  • Envoyer la discussion sur Twitter
  • Envoyer la discussion sur Google
  • Envoyer la discussion sur Facebook
  • Envoyer la discussion sur Digg
  • Envoyer la discussion sur Delicious
  • Envoyer la discussion sur MySpace
  • Envoyer la discussion sur Yahoo